VERSION 5.00
Begin VB.Form frmAnzeige 
   Caption         =   "Rechteck&Trapez"
   ClientHeight    =   6735
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4215
   LinkTopic       =   "Form1"
   ScaleHeight     =   6735
   ScaleWidth      =   4215
   StartUpPosition =   3  'Windows-Standard
   Begin VB.Frame Frame2 
      Caption         =   "Ergebnisse Trapezregel"
      Height          =   1215
      Left            =   360
      TabIndex        =   17
      Top             =   5400
      Width           =   3495
      Begin VB.Label lblFlTra 
         Alignment       =   2  'Zentriert
         BorderStyle     =   1  'Fest Einfach
         Height          =   255
         Left            =   1080
         TabIndex        =   19
         Top             =   720
         Width           =   1455
      End
      Begin VB.Label Label8 
         Caption         =   "Flcheninhalt"
         Height          =   255
         Left            =   1080
         TabIndex        =   18
         Top             =   480
         Width           =   1335
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Ergebnisse Rechteckregel"
      Height          =   2295
      Left            =   360
      TabIndex        =   10
      Top             =   2880
      Width           =   3495
      Begin VB.Label lblFLinks 
         Alignment       =   2  'Zentriert
         BorderStyle     =   1  'Fest Einfach
         Height          =   255
         Left            =   240
         TabIndex        =   16
         Top             =   840
         Width           =   1215
      End
      Begin VB.Label lblFR 
         Alignment       =   2  'Zentriert
         BorderStyle     =   1  'Fest Einfach
         Height          =   255
         Left            =   2040
         TabIndex        =   15
         Top             =   840
         Width           =   1215
      End
      Begin VB.Label Label6 
         Caption         =   "Mittlere Flche"
         Height          =   255
         Left            =   1200
         TabIndex        =   14
         Top             =   1440
         Width           =   1215
      End
      Begin VB.Label Label4 
         Caption         =   "Flche rechter Funktionswert"
         Height          =   375
         Left            =   2040
         TabIndex        =   13
         Top             =   360
         Width           =   1215
      End
      Begin VB.Label lblMitFl 
         Alignment       =   2  'Zentriert
         BorderStyle     =   1  'Fest Einfach
         Height          =   255
         Left            =   960
         TabIndex        =   12
         Top             =   1800
         Width           =   1695
      End
      Begin VB.Label Label7 
         Caption         =   "Flche linker Funktionswert"
         Height          =   375
         Left            =   240
         TabIndex        =   11
         Top             =   360
         Width           =   1215
      End
   End
   Begin VB.CheckBox chkTrapez 
      Alignment       =   1  'Rechts ausgerichtet
      Caption         =   "Trapezregel"
      Height          =   255
      Left            =   2400
      TabIndex        =   9
      Top             =   960
      Width           =   1335
   End
   Begin VB.CheckBox chkRecht 
      Caption         =   "Rechteckregel"
      Height          =   255
      Left            =   240
      TabIndex        =   8
      Top             =   960
      Width           =   1455
   End
   Begin VB.CommandButton btnRechnen 
      Caption         =   "Berechnen"
      Height          =   375
      Left            =   1080
      TabIndex        =   6
      Top             =   2280
      Width           =   1935
   End
   Begin VB.TextBox txtSchritt 
      Alignment       =   2  'Zentriert
      Height          =   285
      Left            =   3120
      TabIndex        =   4
      Top             =   1680
      Width           =   975
   End
   Begin VB.TextBox txtOGr 
      Alignment       =   2  'Zentriert
      Height          =   285
      Left            =   1680
      TabIndex        =   3
      Top             =   1680
      Width           =   975
   End
   Begin VB.TextBox txtUGr 
      Alignment       =   2  'Zentriert
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Top             =   1680
      Width           =   975
   End
   Begin VB.Label Label9 
      Caption         =   "Integral von f(x) = 1/(1+x)"
      Height          =   255
      Left            =   240
      TabIndex        =   20
      Top             =   240
      Width           =   3255
   End
   Begin VB.Label Label5 
      Caption         =   "Berechnung nach:"
      Height          =   255
      Left            =   240
      TabIndex        =   7
      Top             =   600
      Width           =   1455
   End
   Begin VB.Label Label3 
      Caption         =   "Schrittweite"
      Height          =   255
      Left            =   3120
      TabIndex        =   5
      Top             =   1440
      Width           =   1095
   End
   Begin VB.Label Label2 
      Caption         =   "Obere Grenze"
      Height          =   255
      Left            =   1680
      TabIndex        =   2
      Top             =   1440
      Width           =   1095
   End
   Begin VB.Label Label1 
      Caption         =   "Untere Grenze"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   1440
      Width           =   1095
   End
End
Attribute VB_Name = "frmAnzeige"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit


Private Sub btnRechnen_Click()

    Dim FR As Double    'Flche mmit rechtem Funktionswert
    Dim FL As Double    'Flche mit linkem Funkionswert
    Dim UG As Double    'unter Grenze
    Dim OG As Double    'obere Grenze
    Dim SW As Double    'Schrittweite
    Dim Anzahl As Long   'Anzahl der Schritte
    Dim Zaehler As Long  'Zhlvariable
    Dim X() As Double   'Sttzstellen
    Dim Y() As Double   'zugehrige Funktionswerte
    
    Dim FT As Double    'Flche aus der Trapezregel
    
    'zu integrierende Funktion ist gegeben durch
    ' f(x)=1/(1+x)

    If (Len(Me.txtOGr.Text) = 0) Or (Not IsNumeric(Me.txtOGr.Text)) Then
        MsgBox ("Kein gltiger Wert fr obere Grenze!")
        Exit Sub
    End If
    If (Len(Me.txtSchritt.Text) = 0) Or (Not IsNumeric(Me.txtSchritt.Text)) Then
        MsgBox ("Kein gltiger Wert fr Schrittweite!")
        Exit Sub
    End If
    If (Len(Me.txtUGr.Text) = 0) Or (Not IsNumeric(Me.txtUGr.Text)) Then
        MsgBox ("Kein gltiger Wert fr untere Grenze!")
        Exit Sub
    End If
    
    UG = CDbl(Me.txtUGr.Text)
    OG = CDbl(Me.txtOGr.Text)
    SW = CDbl(Me.txtSchritt.Text)
    
    'Ausrechnen der bentigten Schritte
    Anzahl = CLng(Abs(OG - UG) / SW)
    
    ReDim X(Anzahl)
    ReDim Y(Anzahl)
    
    FR = 0
    FL = 0
    FT = 0
   
    For Zaehler = 0 To Anzahl
        If (Zaehler = 0) Then
            X(Zaehler) = UG
        Else
            X(Zaehler) = X(Zaehler - 1) + SW
        End If
        Y(Zaehler) = 1 / (1 + X(Zaehler))
    Next Zaehler
    
    'Prfen, ob Checkbox Rechteckregel ausgewhlt wurde
    If Me.chkRecht.Value <> 0 Then
        'Berechnen der Flche mit rechtem Funktionswert
        For Zaehler = 0 To Anzahl - 1
            FR = FR + Abs(X(Zaehler) - X(Zaehler + 1)) * Y(Zaehler + 1)
        Next Zaehler
    
        'Berechnen der Flche mit linkem Funktionswert
        For Zaehler = 0 To Anzahl - 1
            FL = FL + Abs(X(Zaehler) - X(Zaehler + 1)) * Y(Zaehler)
        Next Zaehler
    
        'Ausgabe in Formular
        Me.lblFLinks.Caption = Round(FL, 4)
        Me.lblFR.Caption = Round(FR, 4)
        Me.lblMitFl.Caption = Round((FR + FL) / 2, 4)
    End If
    
    If Me.chkTrapez.Value <> 0 Then
        For Zaehler = 0 To Anzahl - 1
            FT = FT + (Abs(X(Zaehler) - X(Zaehler + 1))) * (Y(Zaehler) + Y(Zaehler + 1)) / 2
        Next Zaehler
    
        'Ausgabe im Formular
        Me.lblFlTra.Caption = Round(FT, 4)
    End If
       
End Sub

